#include<stdio.h>
#include<stdlib.h>

#define N 100

typedef struct dd
{
	int sm;
	int sn;
}data_type;

typedef struct nn
{
	data_type save[N];
	int top;
}SA;

void init(SA *p);
int insert(SA *p, int m, int n);
int del(SA *p, int *ssm, int *ssn);

void gz(int, int, int *q);
int pd(int h, int l, int *q, int k);
void main()
{
	int hang, lie, m, n, count, r = 0, again = 0, hq = 0, z;
	int ssm, ssn;
	int *q = NULL;
	SA p;

	init(&p);
	printf("ģ");
	scanf("%d*%d", &hang, &lie);
	q = (int *)calloc(hang * lie, sizeof(int));
	if (q == NULL)
	{
		printf("\nʼʧ\n");
		exit(0);
	}
	system("cls");
	gz(hang, lie, q);
	count = 0;
	while(!r)
	{
		count++;
		if (again == 1)
		{
			printf("\n Ƿλã \n");
			count--;
			again = 0;
		}
		printf("壬'%d %d'\n",hang, lie);
		if (count % 2 == 1)
			printf("1, Ҫߵĸӣ");
		if (count % 2 == 0)
			printf("2, Ҫߵĸӣ");
		scanf("%d %d", &m, &n);
		if (m == hang && n == lie)
		{
			hq = 1;
		}
		if (!hq)
		{
			if (*(q + m * lie + n) == 1 || *(q + m * lie + n) == 2 ||  m > hang - 1 || n > lie - 1) 
			{
				again = 1;
			}
			if (again != 1)
			{
				z = insert(&p, m, n);
				if (count % 2 == 0)
				{
					*(q + m * lie + n) = 1;
				}
				else
				{
					*(q + m * lie + n) = 2;
				}
				system("cls");
				gz(hang, lie, q);
				if (count % 2 == 0)
				{
					r = pd(hang, lie, q, 1);
				}
				else
				{
					r = pd(hang, lie, q, 2);
				}
			}
		}
		if (hq)
		{
			hq = 0;
			z = del(&p, &ssm, &ssn);
			if (z)
			{
				*(q + ssm * lie + ssn) = 0;
				system("cls");
				gz(hang, lie, q);
			}
			else
				count--;
		}
	}
	free(q);
	if (count % 2 == 1)
	{
		printf("\nʤ1\n");
	}
	if (count % 2 == 0)
	{
		printf("\nʤ2\n");
	}
	while(1);
}

void gz(int hang, int lie, int *q)
{
	int i, j;
	for (i = 0; i < hang + 1; i ++)
	{
		printf("\n");
		if(i == 0)
		{
			printf("   ");
			for (j = 0;j < lie; j++)
				printf("| %d ", j);
			printf("|");
			printf("\n");
			for (j = 0; j < lie + 1; j++)
				printf("----");
		}
		else
		{
			printf(" %d ", i - 1);
			for (j = 0; j < lie; j++)
			{
				printf("|");
				if (q[(i - 1) * lie + j] == 1)
				{
					printf(" O ");
				}
				else if (q[(i - 1) * lie + j] == 2)
				{
					printf(" X ");
				}
				else
				{
					printf("   ");
				}
			}
			printf("|\n");
			for (j = 0; j < lie + 1; j++)
				printf("----");
		}
	}
	printf("\n");
}

int pd(int h, int l, int *q, int k)
{
	int i, j, r, u = 0;

	for (i = 0; i < h; i++)
	{
		r = 0;
		for (j = 0; j < l; j++)
		{
			if (q[i * l + j] == k)
			{
				r++;
			}
			if (r < 5)
			{
				if(q[i * l + j] != k)
					r = 0;
			}
		}
		if (r >= 5)
			return 1;
	}

	for (i = 0; i < l; i++)
	{
		r = 0;
		for (j = 0; j < h; j++)
		{
			if (q[j * l + i] == k)
			{
				r++;
			}
			if (r < 5)
			{
				if(q[j * l + i] != k)
					r = 0;
			}
		}
		if (r >= 5)
			return 1;
	}

	for (i = 0; i < h; i++)
	{
		r = 0;
		for (j = 0; j < l; j++)
		{
			if (q[i * l + j] == k)
			{
				r = 1;
				for (u = 1; u <= 4; u++)
				{
					if (q[(i + u) * l + (j + u)] == k)
					{
						r++;
					}
					else
						break;
				}
				if (r >= 5)
					return 1;
			}
		}
	}

	for (i = 0; i < h; i++)
	{
		r = 0;
		for (j = 0; j < l; j++)
		{
			if (q[i * l + j] == k)
			{
				r = 1;
				for (u = 1; u <= 4; u++)
				{
					if (q[(i + u)* l + (j - u)] == k)
					{
						r++;
					}
					else
						break;
				}
				if (r >= 5)
					return 1;
			}
		}
	}

	if (r >= 5)
		return 1;
	else 
		return 0;
}

int insert(SA *p, int m, int n)
{
	if (p->top >= N - 1)
	{
		printf("\n, ޷ֳʤƽ!\n");
		exit(0);
	}
	p->top++;
	p->save[p->top].sm = m;
	p->save[p->top].sn = n;
	return 1;
}

void init(SA *p)
{
	p->top = -1;
}

int del(SA *p, int *ssm, int *ssn)
{
	if (p->top <= -1)
	{
		printf("\n\n");
		return 0;
	}
	*ssm = p->save[p->top].sm;
	*ssn = p->save[p->top].sn;
	p->top--;
	return 1;
}